VERSION 5.00
Begin VB.Form dlgMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "TrapKeys"
   ClientHeight    =   3045
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4725
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3045
   ScaleWidth      =   4725
   StartUpPosition =   3  'Windows Default
   Begin VB.OptionButton optmOnlyMonitorNotepad 
      Caption         =   "Only monitor Notepad"
      Height          =   255
      Left            =   2640
      TabIndex        =   5
      Top             =   2280
      Width           =   2055
   End
   Begin VB.OptionButton optmMonitorAllThreads 
      Caption         =   "Monitor all threads"
      Height          =   255
      Left            =   2640
      TabIndex        =   4
      Top             =   1800
      Value           =   -1  'True
      Width           =   1695
   End
   Begin VB.CheckBox chkmBlockW 
      Caption         =   "Block the W Key"
      Height          =   255
      Left            =   2640
      TabIndex        =   3
      Top             =   1200
      Width           =   1815
   End
   Begin VB.TextBox txtmEverything 
      Appearance      =   0  'Flat
      Height          =   2415
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   480
      Width           =   2415
   End
   Begin VB.CommandButton btnmStartNotepad 
      Caption         =   "Start Notepad"
      Height          =   375
      Left            =   2640
      TabIndex        =   2
      Top             =   480
      Width           =   1815
   End
   Begin VB.Label lblmEverything 
      Caption         =   "Everything you type:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "dlgMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'ShellExecute API is used to launch Notepad.
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'Constant used in call to ShellExecute
Private Const SW_SHOWNORMAL = 1

'Object to receive keyboard events must be declared at
'class or form level.
Private WithEvents objmKeyboardEvents As KeyboardEvents
Attribute objmKeyboardEvents.VB_VarHelpID = -1

Private Sub btnmStartNotepad_Click()
    If ShellExecute(Me.hwnd, "Open", "Notepad.exe", "", "", SW_SHOWNORMAL) <= 32 Then
        MsgBox "Unable to start Notepad."
    End If
End Sub

Private Sub Form_Load()
    'Default option is to trap keyboard events from all threads.
    Set objmKeyboardEvents = GetAllThreads.KeyboardEvents
End Sub

Private Sub objmKeyboardEvents_KeyDown(Window As AkemiSpyLibrary.Window, ByVal KeyCode As Integer, ByVal AutoRepeat As Boolean, ByVal Shift As Boolean, ByVal Control As Boolean, ByVal Alt As Boolean, Cancel As Boolean)
    'Add the key that was pressed to the text box.
    txtmEverything.Text = txtmEverything.Text & Chr$(KeyCode)
    
    'Ensure that the last piece of text added to the text box
    'is visible by setting the selection to start at the end of the text.
    txtmEverything.SelStart = Len(txtmEverything.Text)
    
    'If the W key is being blocked, then cancel the keystroke
    'so that other applications don't receive it.
    '(This technique is shown here for educational purposes only.
    'Use of this program to play practical jokes on newly elected
    'heads of state is not in any way condoned by Akemi).
    If chkmBlockW.Value And UCase$(Chr$(KeyCode)) = "W" Then
        Cancel = True
    End If
End Sub

Private Sub optmMonitorAllThreads_Click()
    Set objmKeyboardEvents = GetAllThreads.KeyboardEvents
End Sub

Private Sub optmOnlyMonitorNotepad_Click()
    Dim objNotepadWindow As Window
    
    'Find the first instance of Notepad to come to hand.
    'This example does not account for the possibility of multiple
    'instances of Notepad being open - only the first one to be
    'found will be monitored.
    Set objNotepadWindow = GetTopLevelWindows.FindWindow("* Notepad", "Notepad")
    
    'Check whether an instance of Notepad was found, and
    'display a message if Notepad is not already open.
    If objNotepadWindow Is Nothing Then
        MsgBox "No instances of Notepad currently open."
        optmMonitorAllThreads.Value = True
    Else
        'What we have found is a Window.  The Keyboard events we
        'are going to trap, belong to the Thread of that window.
        Set objmKeyboardEvents = objNotepadWindow.Thread.KeyboardEvents
    End If
End Sub
